/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package FunctionLayer.Caching;

import FunctionLayer.ErrorMessageDisplay;
import FunctionLayer.LogicFacade;
import FunctionLayer.MapBoard;
import FunctionLayer.Users;
import com.google.common.base.Supplier;
import com.google.common.base.Suppliers;
import java.beans.PropertyVetoException;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author install1
 */
public class Guava {

    //https://www.tutorialspoint.com/guava/guava_caching_utilities.htm
    //https://stackoverflow.com/questions/31576136/how-should-i-implement-guava-cache-when-i-plan-to-cache-multiple-values-efficien
    /**
     * @deprecated @return the same list with Values for Usernames, steam ids
     * and avatars on initializing being set
     * @throws ErrorMessageDisplay
     */
    public List<Users> getAllUsersNameSteamIdInitialization() throws ErrorMessageDisplay {
        Supplier<List<Users>> fulllist = Suppliers.memoize(() -> {
            List<Users> users = new ArrayList();
            try {
                users = LogicFacade.getAllUsersNameSteamIdInitialization();
            } catch (SQLException | ErrorMessageDisplay | IOException | PropertyVetoException ex) {
                Logger.getLogger(Guava.class.getName()).log(Level.SEVERE, null, ex);
            }
            return users;
        });
        return fulllist.get();
    }

    /**
     * @deprecated 
     * @return 
     */
    public List<MapBoard> GetAllMapColoumns() {
        Supplier<List<MapBoard>> fulllist = Suppliers.memoize(() -> {
            List<MapBoard> MapColoumns = new ArrayList();
            try {
                MapColoumns = LogicFacade.GetAllMapColoumns();
            } catch (SQLException | ErrorMessageDisplay | IOException | PropertyVetoException ex) {
                Logger.getLogger(Guava.class.getName()).log(Level.SEVERE, null, ex);
            }
            return MapColoumns;
        });
        return fulllist.get();
    }

    
    /*
    /**
     * @deprecated @param PlayerLeaderBoard
     * @return
     
    public List<Users> getAllUsersNameSteamIdUpdates(List<Users> PlayerLeaderBoard) {
        Supplier<List<Users>> fulllist = Suppliers.memoize(() -> {
            List<Users> users = new ArrayList();
            try {
                users = LogicFacade.getAllUsersNameSteamIdUpdates(PlayerLeaderBoard);
            } catch (SQLException | ErrorMessageDisplay | IOException | PropertyVetoException ex) {
                Logger.getLogger(Guava.class.getName()).log(Level.SEVERE, null, ex);
            }
            return users;
        });
        return fulllist.get();
    }*/
    
    /**
     * @deprecated 
     * @param PlayerLeaderBoard
     * @param mapBoard
     * @return 
     */
    public List<Users> getPlayerPointsAndRankInitialization(List<Users> PlayerLeaderBoard, List<MapBoard> mapBoard) {
        Supplier<List<Users>> fulllist = Suppliers.memoize(() -> {
            List<Users> users = new ArrayList();
            try {
                users = LogicFacade.getPlayerPointsAndRankInitialization(PlayerLeaderBoard, mapBoard);
            } catch (SQLException | ErrorMessageDisplay | IOException | PropertyVetoException ex) {
                Logger.getLogger(Guava.class.getName()).log(Level.SEVERE, null, ex);
            }
            return users;
        });
        return fulllist.get();
    }

    /**
     * @deprecated 
     * @param PlayerLeaderBoard
     * @param mapBoard
     * @return 
     */
    public List<Users> getPlayerPointsAndRankUpdates(List<Users> PlayerLeaderBoard, List<MapBoard> mapBoard) {
        Supplier<List<Users>> fulllist = Suppliers.memoize(() -> {
            List<Users> users = new ArrayList();
            try {
                users = LogicFacade.getPlayerPointsAndRankUpdates(PlayerLeaderBoard, mapBoard);
            } catch (SQLException | ErrorMessageDisplay | IOException | PropertyVetoException ex) {
                Logger.getLogger(Guava.class.getName()).log(Level.SEVERE, null, ex);
            }
            return users;
        });
        return fulllist.get();
    }
}
